searchData={"items":[{"type":"module","title":"Ueberauth.Strategy.Oidcc","doc":"OIDC Strategy for Ueberauth.","ref":"Ueberauth.Strategy.Oidcc.html"},{"type":"module","title":"Options - Ueberauth.Strategy.Oidcc","doc":"- uid_field: claim to use for the `uid` field in `Ueberauth.Auth` (default: \"sub\")\n\nSee `UeberauthOidcc.Config` for other configuration.","ref":"Ueberauth.Strategy.Oidcc.html#module-options"},{"type":"function","title":"Ueberauth.Strategy.Oidcc.credentials/1","doc":"Returns the credentials from the oidc response.\n\n`other` includes `id_token`","ref":"Ueberauth.Strategy.Oidcc.html#credentials/1"},{"type":"function","title":"Ueberauth.Strategy.Oidcc.default_options/0","doc":"","ref":"Ueberauth.Strategy.Oidcc.html#default_options/0"},{"type":"function","title":"Ueberauth.Strategy.Oidcc.extra/1","doc":"Returns an `Ueberauth.Auth.Extra` struct containing the claims and userinfo response.","ref":"Ueberauth.Strategy.Oidcc.html#extra/1"},{"type":"function","title":"Ueberauth.Strategy.Oidcc.handle_callback!/1","doc":"Handles the callback from the OIDC provider.","ref":"Ueberauth.Strategy.Oidcc.html#handle_callback!/1"},{"type":"function","title":"Ueberauth.Strategy.Oidcc.handle_request!/1","doc":"Handles the initial authentication request.","ref":"Ueberauth.Strategy.Oidcc.html#handle_request!/1"},{"type":"function","title":"Ueberauth.Strategy.Oidcc.info/1","doc":"Returns a `Ueberauth.Auth.Info` struct populated with the data returned from\nthe userinfo endpoint.\n\nThis information is also included in the `Ueberauth.Auth.Credentials` struct.","ref":"Ueberauth.Strategy.Oidcc.html#info/1"},{"type":"function","title":"Ueberauth.Strategy.Oidcc.uid/1","doc":"Returns the configured uid field from the claims.","ref":"Ueberauth.Strategy.Oidcc.html#uid/1"},{"type":"module","title":"UeberauthOidcc","doc":"`UeberauthOidcc` is two things:\n\n- an implementation of `Ueberauth.Strategy`: see `Ueberauth.Strategy.Oidcc`\n- a set of modules for implementing other OpenID Connect (OIDC) strategies\n(see `UeberauthOidcc.Config`, `UeberauthOidcc.Request`,\n`UeberauthOidcc.Callback`, and `UeberauthOidcc.Error`)","ref":"UeberauthOidcc.html"},{"type":"function","title":"UeberauthOidcc.initiate_logout_url/2","doc":"Create a logout URL for a given `t:Ueberauth.Auth.t/0` struct.\n\nAlso takes a an map of query parameters to append to the URL.","ref":"UeberauthOidcc.html#initiate_logout_url/2"},{"type":"function","title":"UeberauthOidcc.initiate_logout_url/3","doc":"Create a logout URL.\n\nTakes a `UeberauthOidcc.Config.t()`, an ID token value, and parameters to append to the URL.","ref":"UeberauthOidcc.html#initiate_logout_url/3"},{"type":"module","title":"UeberauthOidcc.Auth","doc":"Helper functions for converting an `Oidcc.Token.t()` and userinfo into `Ueberauth.Auth` structs.","ref":"UeberauthOidcc.Auth.html"},{"type":"function","title":"UeberauthOidcc.Auth.credentials/1","doc":"Convert an `Oidcc.Token.t()` into an `Ueberauth.Auth.Credentials.t()`\n\nThe ID token value is in the `extra` map as `id_token`.","ref":"UeberauthOidcc.Auth.html#credentials/1"},{"type":"function","title":"UeberauthOidcc.Auth.info/2","doc":"Converts an `Oidcc.Token.t()` and optional userinfo claims to an `Ueberauth.Auth.Info.t()`\n\nUses the [OpenID Connect standard claims](https://openid.net/specs/openid-connect-basic-1_0.html#StandardClaims).","ref":"UeberauthOidcc.Auth.html#info/2"},{"type":"module","title":"UeberauthOidcc.Callback","doc":"Support implementation of `c:Ueberauth.Strategy.handle_callback!/1`","ref":"UeberauthOidcc.Callback.html"},{"type":"function","title":"UeberauthOidcc.Callback.handle_callback/2","doc":"Support implementation of `c:Ueberauth.Strategy.handle_callback!/1`\n\nTakes options and the `Plug.Conn.t()`, and returns either an updated\n`Plug.Conn.t()`, a token and the userinfo claims, or an error (and the\nupdated conn).\n\nSee `UeberauthOidcc.Error.set_described_error/3` for help with rendering the\nerror.","ref":"UeberauthOidcc.Callback.html#handle_callback/2"},{"type":"module","title":"UeberauthOidcc.Config","doc":"Functions for managing the configuration passed to request/callback modules.\n\nSee `t:t/0` for the supported values.","ref":"UeberauthOidcc.Config.html"},{"type":"function","title":"UeberauthOidcc.Config.default/0","doc":"Default options for UeberauthOidcc.","ref":"UeberauthOidcc.Config.html#default/0"},{"type":"function","title":"UeberauthOidcc.Config.merge_and_expand_configuration/1","doc":"Given a list of configurations (either as maps or keyword lists), merges them together.\n\nThis starts with the default options (see `default/0`), and merges each\nconfiguration one at a time, taking the last value.\n\nIn addition to bare values (strings, atoms, numbers), some other types are accepted:\n- a 0-arity function\n- `{:system,  }` which will use the value of the environment variable if it's defined\n- `{:system,  ,  }` which will use the value of the environment variable if defined, otherwise the default\n- `{mod, fun, args}` which will apply the given MFA tuple","ref":"UeberauthOidcc.Config.html#merge_and_expand_configuration/1"},{"type":"type","title":"UeberauthOidcc.Config.t/0","doc":"Configuration taken by the request/callback modules.\n\n**Required**:\n- issuer: the name of an `Oidcc.ProviderConfiguration.Worker` to use for configuration\n- client_id: the client ID to use\n- client_secret: the client secret to use\n- redirect_uri: the full URI to redirect back to after authentication\n\n__Optional__:\n- session_cookie: name of cookie used store data between the request and callback (default: `\"_ueberauth_strategy_oidcc\"`)\n- session_key: secret name to use with `Plug.Crypto.encrypt/4` (default: `\"ueberauth_strategy_oidcc\"`)\n- session_max_age: maximum number of seconds allowed between the request and callback (default: `3600`)\n- session_same_site: SameSite value to use for the session cookie (default: `\"Lax\"`)\n- scopes: list of scopes to request (default: `[\"openid\"]`)\n- authorization_params: map of additional parameters to pass in the query to the authorization_endpoint\n- authorization_params_passthrough: list of params which can be passed through from the initial request\n- authorization_endpoint: override the authorization_endpoint defined by the issuer\n- token_endpoint: override the token_endpoint defined by the issuer\n- userinfo: whether to request the userinfo endpoint (default: `false`)\n- userinfo_endpoint: override the userinfo_endpoint defined by the issuer\n- validate_scopes: whether to validate that the returned scopes are a subset of the requested scopes (default: `false`)\n\nThe `session_cookie` name will also be prefixed with `__Secure-` if the\nrequest comes over HTTPS to ensure that browsers only send it securely.\n\nYou can also give any options taken by the `Oidcc.create_redirect_url/4` or\n`Oidcc.retrieve_token/5` functions.\n\nFor testing:\n- module: (default: `Oidcc`)\n- response_type: (default: `\"code\"`)","ref":"UeberauthOidcc.Config.html#t:t/0"},{"type":"module","title":"UeberauthOidcc.Error","doc":"Handles errors returned from the request/callback functions.","ref":"UeberauthOidcc.Error.html"},{"type":"function","title":"UeberauthOidcc.Error.describe_error/2","doc":"Renders the given error as an `Ueberauth.Failure.Error.t()`.\n\n`message_key` will be used as the default `message_key` if a better one is\nunavailable.","ref":"UeberauthOidcc.Error.html#describe_error/2"},{"type":"function","title":"UeberauthOidcc.Error.set_described_error/3","doc":"Renders the given error reason as an `Ueberauth.Failure.t()` on the\n`Plug.Conn.t()`.\n\n`message_key` will be used as the default `message_key` if a better one is\nunavailable.","ref":"UeberauthOidcc.Error.html#set_described_error/3"},{"type":"module","title":"UeberauthOidcc.RawInfo","doc":"Struct for the data passed to the callback as the `raw_info` in  `Ueberauth.Auth.Extra`.","ref":"UeberauthOidcc.RawInfo.html"},{"type":"type","title":"UeberauthOidcc.RawInfo.string_map/0","doc":"","ref":"UeberauthOidcc.RawInfo.html#t:string_map/0"},{"type":"type","title":"UeberauthOidcc.RawInfo.t/0","doc":"","ref":"UeberauthOidcc.RawInfo.html#t:t/0"},{"type":"module","title":"UeberauthOidcc.Request","doc":"Support implementation of `c:Ueberauth.Strategy.handle_request!/1`","ref":"UeberauthOidcc.Request.html"},{"type":"function","title":"UeberauthOidcc.Request.handle_request/2","doc":"Support implementation of `c:Ueberauth.Strategy.handle_request!/1`\n\nTakes options and the `Plug.Conn.t()`, and returns either an updated\n`Plug.Conn.t()` redirected to the authentication endpoint, or an error\n(and the updated conn).\n\nSee `UeberauthOidcc.Error.set_described_error/3` for help with rendering the\nerror.","ref":"UeberauthOidcc.Request.html#handle_request/2"},{"type":"module","title":"UeberauthOidcc.Session","doc":"Manages session information for an UeberauthOidcc request.","ref":"UeberauthOidcc.Session.html"},{"type":"function","title":"UeberauthOidcc.Session.delete/2","doc":"","ref":"UeberauthOidcc.Session.html#delete/2"},{"type":"function","title":"UeberauthOidcc.Session.get/3","doc":"","ref":"UeberauthOidcc.Session.html#get/3"},{"type":"function","title":"UeberauthOidcc.Session.put/3","doc":"","ref":"UeberauthOidcc.Session.html#put/3"},{"type":"extras","title":"UeberauthOidcc","doc":"# UeberauthOidcc\n\n![pipeline status badge](https://gitlab.com/paulswartz/ueberauth_oidcc/badges/main/pipeline.svg)\n![coverage badge](https://gitlab.com/paulswartz/ueberauth_oidcc/badges/main/coverage.svg)\n![latest release badge](https://gitlab.com/paulswartz/ueberauth_oidcc/-/badges/release.svg)\n\n`UeberauthOidcc` is two things:\n\n- an implementation of [Ueberauth.Strategy](https://hexdocs.pm/ueberauth/Ueberauth.Strategy.html) based on the [Oidcc](https://hexdocs.pm/oidcc/readme.html) library\n- a set of modules for implementing other OpenID Connect (OIDC) strategies","ref":"readme.html"},{"type":"extras","title":"Installation - UeberauthOidcc","doc":"The package can be installed by adding `ueberauth_oidcc` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ueberauth_oidcc, \"~> 0.3.2\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - UeberauthOidcc","doc":"1. Add an OIDC Issuer to your Ueberauth configuration.\n\nAn issuer is a single OIDC endpoint, but it can be shared by multiple\n`Ueberauth.Strategy.Oidcc` providers.\n\n``` elixir\nconfig :ueberauth_oidcc, :issuers, [\n  %{name: :oidcc_issuer, issuer: \" \"}\n]\n```\n\nThe issuer must provide OIDC configuration at ` /.well-known/openid-configuration`.\n\nSee\n[oidcc_provider_configuration:opts/0](https://hexdocs.pm/oidcc/oidcc_provider_configuration.html#t:opts/0) for issuer parameters.\n\n2. Add the `Ueberauth.Strategy.Oidcc` strategy to your configuration.\n\nSee [UeberauthOidcc.Config](https://hexdocs.pm/ueberauth_oidcc/UeberauthOidcc.Config.html) for supported options.\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    oidc: { Ueberauth.Strategy.Oidcc,\n      issuer: :oidcc_issuer, # matches the name above\n      client_id: \"client_id\",\n      client_secret: \"123456789\",\n      scopes: [\"openid\", \"profile\", \"email\"],\n      # optional\n      callback_path: \"/auth/oidc/callback\",\n      userinfo: true, # whether to pull info from the Userinfo endpoint, default: false\n      validate_scopes: true, # whether to validate the returned scopes are a subset of those request, default: false\n      uid_field: \"email\", # pulled from the merge of the claims and userinfo (if fetched), default: sub\n      authorization_params: %{}, # additional parameters for the authorization request\n      authorization_params_passthrough: [], # params to pass through from the incoming request (such as \"prompt\")\n      authorization_endpoint: \"https://oidc-override/request\" # override the initial request URI\n    }\n  ]\n```\nThe core Ueberauth configuration is only read at compile time, so if you have runtime configuration you'll need to use one of two approaches:\n\n1. Use a `{module, fun, args}` tuple or `{:system,  }` tuple.\n\n``` elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    oidc: { Ueberauth.Strategy.Oidcc,\n      issuer: :oidcc_issuer,\n      client_id: {:system, \"CLIENT_ID\"},\n      client_secret: {System, :get_env, [\"CLIENT_SECRET\"]}\n    }\n  ]\n```\n\n2. Put it under the `:ueberauth_oidcc` `:providers` config. \n\n```elixir\n # config/runtime.exs\n config :ueberauth_oidcc, :providers,\n  oidc: [\n    client_secret: System.fetch_env!(\"OIDC_CLIENT_SECRET\")\n  ]\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - UeberauthOidcc","doc":"1. Include the Ueberauth plug in your controller:\n\n```elixir\ndefmodule MyApp.AuthController do\n  use MyApp.Web, :controller\n  plug Ueberauth\n  ...\nend\n```\n\n2. Create the request and callback routes if you haven't already:\n\n```elixir\nscope \"/auth\", MyApp do\n  pipe_through :browser\n\n  get \"/:unused\", AuthController, :request\n  get \"/:unused/callback\", AuthController, :callback\nend\n```\n\n3. Your controller needs to implement `callback/2` to deal with `Ueberauth.Auth`\nand `Ueberauth.Failure` responses. For an example implementation see the\n[Ueberauth Example](https://github.com/ueberauth/ueberauth_example) application.\n\n   - `Ueberauth.Auth.Credentials` contains the `access_token` and related fields\n     - The `other` map in `Ueberauth.Auth.Credentials` contains `id_token`\n   - `Ueberauth.Auth.Extra` contains the raw claims, userinfo, and options","ref":"readme.html#usage"},{"type":"extras","title":"Calling - UeberauthOidcc","doc":"Depending on the configured url, you can initialize the request through:\n\n    /auth/oidc","ref":"readme.html#calling"},{"type":"extras","title":"Documentation - UeberauthOidcc","doc":"Documentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand or found at  .","ref":"readme.html#documentation"},{"type":"extras","title":"License - UeberauthOidcc","doc":"Released under the MIT License. Please see [LICENSE](./LICENSE) for details.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.3.3 - 2024-04-20 - Changelog","doc":"- fix(session): ensure that we clear the session cookie","ref":"changelog.html#v0-3-3-2024-04-20"},{"type":"extras","title":"v0.3.2 - 2024-03-06 - Changelog","doc":"This release includes some features/fixes backported from the 0.4.x series.\n\n- feat: store session data in a separate UeberauthOidcc cookie\n- feat: include config `authorization_params_passthrough` to optionally copy incoming parameters\n- fix: support multiple issuers\n- fix: limit `nonce` to 43 characters","ref":"changelog.html#v0-3-2-2024-03-06"},{"type":"extras","title":"v0.3.1 - 2023-12-10 - Changelog","doc":"- fix: refresh JWKs if needed (#5)","ref":"changelog.html#v0-3-1-2023-12-10"},{"type":"extras","title":"v0.3.0 - 2023-12-05 - Changelog","doc":"The big change in 0.3.0 is refactoring the implementation into various\nsub-modules. This allows them to serve as implementations for other Ueberauth\nstrategies which use OIDC, by passing in different opts.\n\n- feat: support overriding the token_endpoint\n- doc: add the `uid_field` to the list of options\n- feat: add some additional error descriptions\n- refactor!: pull implementation into UeberauthOidcc modules\n\nBREAKING CHANGE: if you were using `module` for testing, you'll need to\nimplement some additional sub-modules: `ClientContext`, `Authorization`, `Token`\nand `Userinfo`.","ref":"changelog.html#v0-3-0-2023-12-05"},{"type":"extras","title":"v0.2.0 - 2023-12-01 - Changelog","doc":"- fix!: switch runtime environment key to `providers` (BREAKING CHANGE)\n- fix: ensure `Ueberauth.Failure.Error` message is a binary\n- feat: (optional) verify returned scopes\n- feat: verify PKCE, nonce, and redirect_uri","ref":"changelog.html#v0-2-0-2023-12-01"},{"type":"extras","title":"v0.1.0 - 2023-11-29 - Changelog","doc":"- fix: wrap raw_info in a struct to avoid logging the opts\n- chore: update to Oidcc 3.1.0\n- fix: fail if the ID token has an invalid nonce\n- feat: support none alg for the ID token (if Userinfo is fetched)\n- feat: support Elixir 1.14.4","ref":"changelog.html#v0-1-0-2023-11-29"},{"type":"extras","title":"v0.1.0-rc.0 - 2023-11-21 - Changelog","doc":"- Initial release","ref":"changelog.html#v0-1-0-rc-0-2023-11-21"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2023 Paul Swartz\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/markdown"}